#property copyright "*"
#property link      "*"
#define coder "http://dmffx.com, for-good-letters@yandex.ru"
#property show_inputs

/*
   SaveAsSymbol - ,     
   SaveAsTimeFrame - ,  ,   
   TimeTimeFrame -   ,   
   StartDate -   
   BarsCount -  
   VolumeMin -   
   VolumeMax -   
   VolumeDifMin -     . ! VolumeDifMax-VolumeDifMin    VolumeMax-VolumeMin
   VolumeDifMax -     
   VolumeAddRnd -     ,     
   MinTick -  
   MaxTick -  
   StartPrice -  
   digits -   
   GapProbability -  
   GapMax -  


*/

extern string     SaveAsSymbol      =  "RP";       // ,     
extern int        SaveAsTimeFrame   =  1;          // ,  ,   
extern int        TimeTimeFrame     =  1;          //   ,   
extern datetime   StartDate         =  0;          //   
extern int        BarsCount         =  10000;      //  
extern int        VolumeMin         =  1;          //    
extern int        VolumeMax         =  30;         //   
extern int        VolumeDifMin      =  3;          //     . ! VolumeDifMax-VolumeDifMin    VolumeMax-VolumeMin
extern int        VolumeDifMax      =  15;         //     
extern bool       VolumeAddRnd      =  50;         //     ,     
extern int        MinTick           =  1;          //  
extern int        MaxTick           =  3;          //  
extern double     StartPrice        =  1.0;        //  
extern int        digits            =  4;          //   
extern double     GapProbability    =  0.001;      //  
extern int        GapMax            =  50;         //  



/*
1.    ""  "".     .

2.      ,  .

3.    ,   1-  3- . 

3.       .2.    "" .

4.   .        (  )           .2.   /  1.  /   /   .

5.     .4.       .        (.3.),    (  ),       ...  High, Low. ..  .

*/

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start(){

   Comment(": 0.00%");
   
   MathSrand(TimeLocal());

   int    i_unused[13];

   int h=FileOpenHistory(SaveAsSymbol+SaveAsTimeFrame+".hst",FILE_BIN|FILE_WRITE);
   if(h<0) return(-1);
   
   int h2=FileOpen(SaveAsSymbol+SaveAsTimeFrame+".csv",FILE_CSV|FILE_WRITE,",");
   if(h2<0) return(-1);   

   string cr="(C)opyright 2003, MetaQuotes Software Corp.";
   int version=400;
   FileWriteInteger(h,version,LONG_VALUE);
   FileWriteString(h,cr,64);
   FileWriteString(h,SaveAsSymbol,12);
   FileWriteInteger(h,SaveAsTimeFrame,LONG_VALUE);
   FileWriteInteger(h,digits,LONG_VALUE);
   FileWriteInteger(h,0,LONG_VALUE); 
   FileWriteInteger(h,0,LONG_VALUE);
   FileWriteArray(h,i_unused,0,13);
   
   
   double MyPoint=NormalizeDouble(1.0/MathPow(10,digits),digits);

   double open=StartPrice;
   double high=open;   
   double low=open;  
   double close=open;
   datetime time=StartDate;
   double volume=Rnd(VolumeMin,VolumeMax); 
   
   datetime lt=TimeLocal();
      for(int i=0;i<BarsCount && !IsStopped();i++){
            if(TimeLocal()>lt){
               lt=TimeLocal();
               Comment(": "+DS2(100.0*i/BarsCount)+"%");
               Sleep(1);
            }
            for(int k=1;k<volume;k++){
               close+=MyPoint*MyTick();
               high=MathMax(high,close);
               low=MathMin(low,close);
            }

         // ====  ====

         FileWriteInteger(h,time,LONG_VALUE);
         FileWriteDouble(h,open,DOUBLE_VALUE);
         FileWriteDouble(h,low,DOUBLE_VALUE);
         FileWriteDouble(h,high,DOUBLE_VALUE);
         FileWriteDouble(h,close,DOUBLE_VALUE);
         FileWriteDouble(h,volume,DOUBLE_VALUE);
         
         FileWrite(h2,TimeYear(time)+"."+F(TimeMonth(time))+"."+F(TimeDay(time)),F(TimeHour(time))+":"+F(TimeMinute(time)),DSD(open,digits),DSD(high,digits),DSD(low,digits),DSD(close,digits),DSD(volume,0));

         // ====
         
         open=close+MyPoint*MyTick();

            if(RndEvent(GapProbability)){
               open+=MyPoint*RndS()*Rnd(0,GapMax);
            }
         
         high=open;   
         low=open;  
         close=open; 
         volume=volume+RndS()*Rnd(VolumeDifMin,VolumeDifMax);
         if(volume>VolumeMax)volume=VolumeMax-(volume-VolumeMax);
         if(volume<VolumeMin)volume=VolumeMin+(VolumeMin-volume);  
         volume+=Rnd(0,VolumeAddRnd);
         time+=TimeTimeFrame*60;       
      }
   FileClose(h);
   FileClose(h2);   
   Comment(": 100.0%");
   Sleep(100);
   Comment("");
   
   Alert(WindowExpertName()+": ! .  "+SaveAsSymbol+","+fTimeFrameName(SaveAsTimeFrame)+" (. )  "+SaveAsSymbol+","+fTimeFrameName(SaveAsTimeFrame)+".csv ( experts/files)");

   return(0);
}

int deinit(){
   Comment("");
}

string F(int A){
   if(A<10)return("0"+A);
   return(A);
}


string DSD(double v,int d){return(DoubleToStr(v,d));}


string DS2(double v){return(DoubleToStr(v,2));}

int MyTick(){
   return(RndS()*Rnd(MinTick,MaxTick));
}

bool RndEvent(double Probability){
   double t=MathRand();
   if(t==32767)t--;
   t/=32767;
   return(t<Probability);
}

int RndS(){
   int r=0;
      while(r==0){
         r=MathRand()-MathRand();
      }
   r/=MathAbs(r);
   return(r);
}

int Rnd(int aFrom,int aTo){
   double t=MathRand();
   t/=32767;
   t=MathRound(t*(aTo-aFrom)+aFrom);
   return(t);   
}

string fTimeFrameName(int arg){
      if(arg==0){
         arg=Period();
      }
      switch(arg){
         case 0:
            return("0");
         case 1:
            return("M1");
         case 5:
            return("M5");                  
         case 15:
            return("M15");
         case 30:
            return("M30");             
         case 60:
            return("H1");
         case 240:
            return("H4");                  
         case 1440:
            return("Dayly");
         case 10080:
            return("Weekly");          
         case 43200:
            return("Monthly");
         default:
            return("M"+arg);          
      }
}

